unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,
  Skelet;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private // private declarations:
    Hlava: TSkelet;
  public  // public declarations:
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

// TDancingSkelet:

type
  TRubberSkelet=class(TSkelet)
  private
    FIsXY: Boolean;
    FRatio: Real;
  protected
    procedure DoStep; override;
  public
    constructor Create(Parent: TSkelet; dX, dY: Integer; Ratio: Real);
    property Ratio: Real read FRatio write FRatio;
  end;

constructor TRubberSkelet.Create(Parent: TSkelet; dX, dY: Integer; Ratio: Real);
begin
  inherited Create(Parent, dX, dY);
  FRatio:=Ratio;
end;

procedure TRubberSkelet.DoStep;
begin
  if Parent=nil then inherited
  else
    if not FIsXY then begin
      inherited;
      FIsXY:=True;
    end else begin
      X:=Round((1-Ratio)*X+Ratio*(Parent.X+dX));
      Y:=Round((1-Ratio)*Y+Ratio*(Parent.Y+dY));
    end;
end;

// TForm:

procedure TForm1.FormCreate(Sender: TObject);
var
  Krk, Trup: TSkelet;
begin
  Hlava:=TSkelet.Create(nil, Image1.Width div 2, Image1.Height div 7);
  Krk:=TRubberSkelet.Create(Hlava, 0, 10, 0.5);
  TRubberSkelet.Create(Krk, -20, 50, 0.25);
  TRubberSkelet.Create(Krk, +20, 50, 0.25);
  Trup:= TRubberSkelet.Create(Krk, 0, 70, 0.25);
  TRubberSkelet.Create(Trup, -20, 70, 0.125);
  TRubberSkelet.Create(Trup, +20, 70, 0.125);
  Hlava.Step;
  Hlava.Paint(Image1.Canvas);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Hlava.Free;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Hlava.Step;
  Image1.Canvas.FillRect(ClientRect);
  Hlava.Paint(Image1.Canvas);
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if ssLeft in shift then begin
    Hlava.dX:=X;
    Hlava.dY:=Y;
  end;
end;

end.
